(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("immutable"));
	else if(typeof define === 'function' && define.amd)
		define(["immutable"], factory);
	else if(typeof exports === 'object')
		exports["asteroidImmutableMixin"] = factory(require("immutable"));
	else
		root["asteroidImmutableMixin"] = factory(root["immutable"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_1__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	var _immutable = __webpack_require__(1);

	var _immutable2 = _interopRequireDefault(_immutable);

	var _handlers = __webpack_require__(2);

	var _getServiceConfig = __webpack_require__(4);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function init() {
	    this.collections = _immutable2.default.Map();
	    this.ddp.on("added", _handlers.added.bind(this));
	    this.ddp.on("changed", _handlers.changed.bind(this));
	    this.ddp.on("removed", _handlers.removed.bind(this));
	}

	module.exports = {
	    init: init,
	    getServiceConfig: _getServiceConfig.getServiceConfig
	};

/***/ },
/* 1 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_1__;

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	exports.added = added;
	exports.changed = changed;
	exports.removed = removed;

	var _immutable = __webpack_require__(1);

	var _immutable2 = _interopRequireDefault(_immutable);

	var _normalizeId = __webpack_require__(3);

	var _normalizeId2 = _interopRequireDefault(_normalizeId);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function added(_ref) {
	    var collection = _ref.collection;
	    var id = _ref.id;
	    var fields = _ref.fields;

	    var _id = (0, _normalizeId2.default)(id);
	    // TODO `fields` might be empty. Find out if true and document why
	    var element = _immutable2.default.fromJS(_extends({}, fields, { _id: _id }));
	    this.collections = this.collections.setIn([collection, _id], element);
	    this.emit("collections:change", "added", collection, _id);
	}

	function changed(_ref2) {
	    var collection = _ref2.collection;
	    var id = _ref2.id;
	    var fields = _ref2.fields;
	    var cleared = _ref2.cleared;

	    var _id = (0, _normalizeId2.default)(id);
	    if (fields) {
	        this.collections = this.collections.mergeIn([collection, _id], fields);
	    }
	    if (cleared) {
	        this.collections = cleared.reduce(function (collections, field) {
	            return collections.deleteIn([collection, _id, field]);
	        }, this.collections);
	    }
	    this.emit("collections:change", "changed", collection, _id);
	}

	function removed(_ref3) {
	    var collection = _ref3.collection;
	    var id = _ref3.id;

	    var _id = (0, _normalizeId2.default)(id);
	    this.collections = this.collections.deleteIn([collection, _id]);
	    this.emit("collections:change", "removed", collection, _id);
	}

/***/ },
/* 3 */
/***/ function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	exports.default = normalizeId;
	function normalizeId(id) {
	    /*
	    *   When elements of a collection have an ObjectId as _id, the
	    *   stringification of the ObjectId meteor does before sending the element
	    *   to the client prepends a dash `-` to the normal stringification of the
	    *   _id. See https://github.com/meteor/meteor/issues/1679 for details.
	    */
	    return id[0] === "-" ? id.slice(1) : id;
	}

/***/ },
/* 4 */
/***/ function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	exports.getServiceConfig = getServiceConfig;
	var SERVICE_CONFIG_COLLECTION = "meteor_accounts_loginServiceConfiguration";

	function getServiceConfig(providerName) {
	    try {
	        return this.collections.get(SERVICE_CONFIG_COLLECTION).find(function (serviceConfig) {
	            return serviceConfig.get("service") === providerName;
	        }).toJS();
	    } catch (ignore) {
	        throw new Error("No configuration found for provider " + providerName);
	    }
	}

/***/ }
/******/ ])
});
;